function cartgrid(M, dx, N, dy)
    x = fftfreq(M, M*dx) |> fftshift
    y = fftfreq(N, N*dy) |> fftshift

    ndgrid(x, y)
end

function polargrid(M, dx, N, dy)
    x = fftfreq(M, M*dx) |> fftshift
    y = fftfreq(N, N*dy) |> fftshift

    grid = ndgrid(x, y)
    cart2pol!(grid...)
    ϕ, r = grid
    r, ϕ
end

pol2cart(ϕ, r) = r .* sincos(ϕ)
# special function operating in-place on 2d grid
function pol2cart!(ϕ, r) # ϕ -> x, r -> y
    @inbounds for k ∈ eachindex(ϕ, r)
        r[k], ϕ[k] = pol2cart(ϕ[k], r[k])# r[k] .* sincos(ϕ[k])
    end
end


cart2pol(x, y) = atan(y, x), hypot(x, y)
# special function operating in-place on 2d grid
function cart2pol!(x, y) # x -> ϕ, y -> r
    @inbounds for k ∈ eachindex(x, y)
        x[k], y[k] = cart2pol(x[k], y[k])
    end
end